/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.search.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="BENUTZER_SUCHPARAMETER.UK",
     query="SELECT o FROM BenutzerSuchparameter o WHERE "

                         + "o"
                +".benutzerkennung"
              +" = ?1"

             +" AND "         + "o"
                +".name"
              +" = ?2"

             +" AND "         + "o"
                +".viewId"
              +" = ?3"

             +" AND "         + "o"
                +".wahl"
                +".wahlart"
                +".name"
              +" = ?4"

             +" AND "         + "o"
                +".wahl"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?5"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".nummer"
              +" = ?6"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".wahldatum"
              +" = ?7"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?8"

             +" AND "         + "o"
                +".wahltermin"
                +".nummer"
              +" = ?9"

             +" AND "         + "o"
                +".wahltermin"
                +".wahldatum"
              +" = ?10"

             +" AND "         + "o"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?11"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="BENUTZER_SUCHPARAMETER.WahlterminBenutzerkennungViewIdName",
     query="SELECT o FROM BenutzerSuchparameter o WHERE o.wahltermin=?1 AND o.benutzerkennung=?2 AND o.viewId=?3 AND o.name=?4",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="BENUTZER_SUCHPARAMETER.WahlterminBenutzerkennungViewId",
     query="SELECT o FROM BenutzerSuchparameter o WHERE o.wahltermin=?1 AND o.benutzerkennung=?2 AND o.viewId=?3 ORDER BY o.name",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="BENUTZER_SUCHPARAMETER.WahlterminWahlBenutzerkennungViewIdName",
     query="SELECT o FROM BenutzerSuchparameter o WHERE o.wahltermin=?1 AND o.wahl=?2 AND o.benutzerkennung=?3 AND o.viewId=?4 AND o.name=?5",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="BENUTZER_SUCHPARAMETER.WahlterminWahlBenutzerkennungViewId",
     query="SELECT o FROM BenutzerSuchparameter o WHERE o.wahltermin=?1 AND o.wahl=?2 AND o.benutzerkennung=?3 AND o.viewId=?4 ORDER BY o.name",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "BENUTZER_SUCHPARAMETER")
// @javax.persistence.IdClass(BenutzerSuchparameterPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class BenutzerSuchparameter
extends AbstractBenutzerSuchparameter
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public BenutzerSuchparameter() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public BenutzerSuchparameter(BenutzerSuchparameter original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "benutzer_suchparameter_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "BenutzerSuchparameter")
    @javax.persistence.TableGenerator(name = "BenutzerSuchparameter", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "BenutzerSuchparameter", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient BenutzerSuchparameterPK pkCache;

  @Override
  public BenutzerSuchparameterPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new BenutzerSuchparameterPK(getId());
    }

    return pkCache;
  }

  public static <E extends BenutzerSuchparameter> java.util.Map<BenutzerSuchparameterPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<BenutzerSuchparameterPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends BenutzerSuchparameter> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedBenutzerkennung = false;
          hasChangedName = false;
          hasChangedSuchparameter = false;
          hasChangedViewId = false;
  
      hasChangedWahltermin = false;
        hasChangedWahl = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
      @javax.persistence.Column(name = "BENUTZERKENNUNG", nullable = BenutzerSuchparameterConstants.BENUTZERKENNUNG_NULLABLE, length=BenutzerSuchparameterConstants.BENUTZERKENNUNG_MAX_LENGTH)
        
  protected java.lang.String benutzerkennung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBenutzerkennung = false;

  public boolean hasChangedBenutzerkennung(){
    return hasChangedBenutzerkennung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBenutzerkennung = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBenutzerkennung;
  
  /**
   * 
   *
   * getter for BENUTZER_SUCHPARAMETER.BENUTZERKENNUNG
   */
    @Override   public  java.lang.String getBenutzerkennung() {
        return benutzerkennung;
      }

  /**
   * 
   *
   * setter for BENUTZER_SUCHPARAMETER.BENUTZERKENNUNG
   *
   * @param benutzerkennung
   */
  @Override   public void setBenutzerkennung( java.lang.String benutzerkennung) {

       resetTkCache();
                  
                          java.lang.String benutzerkennungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(benutzerkennung, BenutzerSuchparameterConstants.BENUTZERKENNUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.benutzerkennung
      , benutzerkennungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBenutzerkennung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("benutzerkennung");
      }


             if (!isSeitLadenVeraendertBenutzerkennung) {
          isSeitLadenVeraendertBenutzerkennung = thisAttributChanged;
         if (isSeitLadenVeraendertBenutzerkennung){
           wertNachLadenBenutzerkennung=this.benutzerkennung;
         }
       }
      

       this.benutzerkennung = benutzerkennungInternal;

         }

        
      @javax.persistence.Column(name = "NAME", nullable = BenutzerSuchparameterConstants.NAME_NULLABLE, length=BenutzerSuchparameterConstants.NAME_MAX_LENGTH)
        
  protected java.lang.String name =  null;

  @javax.persistence.Transient
  protected boolean hasChangedName = false;

  public boolean hasChangedName(){
    return hasChangedName;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertName = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenName;
  
  /**
   * 
   *
   * getter for BENUTZER_SUCHPARAMETER.NAME
   */
    @Override   public  java.lang.String getName() {
        return name;
      }

  /**
   * 
   *
   * setter for BENUTZER_SUCHPARAMETER.NAME
   *
   * @param name
   */
  @Override   public void setName( java.lang.String name) {

       resetTkCache();
                  
                          java.lang.String nameInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(name, BenutzerSuchparameterConstants.NAME_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.name
      , nameInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedName |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("name");
      }


             if (!isSeitLadenVeraendertName) {
          isSeitLadenVeraendertName = thisAttributChanged;
         if (isSeitLadenVeraendertName){
           wertNachLadenName=this.name;
         }
       }
      

       this.name = nameInternal;

         }

        
  @javax.persistence.Basic(fetch=javax.persistence.FetchType.LAZY)
  @javax.persistence.Lob
      @javax.persistence.Column(name = "SUCHPARAMETER", nullable = BenutzerSuchparameterConstants.SUCHPARAMETER_NULLABLE, length = Integer.MAX_VALUE)
    
  protected java.lang.String suchparameter =  null;

  @javax.persistence.Transient
  protected boolean hasChangedSuchparameter = false;

  public boolean hasChangedSuchparameter(){
    return hasChangedSuchparameter;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertSuchparameter = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenSuchparameter;
  
  /**
   * 
   *
   * getter for BENUTZER_SUCHPARAMETER.SUCHPARAMETER
   *
   * (LAZY LOADING)
   */
    @Override   public  java.lang.String getSuchparameter() {
        return suchparameter;
      }

  /**
   * 
   *
   * setter for BENUTZER_SUCHPARAMETER.SUCHPARAMETER
   *
   * @param suchparameter
   */
  @Override   public void setSuchparameter( java.lang.String suchparameter) {

       resetTkCache();
                  java.lang.String suchparameterInternal = org.apache.commons.lang3.StringUtils.trimToNull(suchparameter);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.suchparameter
      , suchparameterInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedSuchparameter |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("suchparameter");
      }


             if (!isSeitLadenVeraendertSuchparameter) {
          isSeitLadenVeraendertSuchparameter = thisAttributChanged;
         if (isSeitLadenVeraendertSuchparameter){
           wertNachLadenSuchparameter=this.suchparameter;
         }
       }
      

       this.suchparameter = suchparameterInternal;

         }

        
      @javax.persistence.Column(name = "VIEW_ID", nullable = BenutzerSuchparameterConstants.VIEW_ID_NULLABLE, length=BenutzerSuchparameterConstants.VIEW_ID_MAX_LENGTH)
        
  protected java.lang.String viewId =  null;

  @javax.persistence.Transient
  protected boolean hasChangedViewId = false;

  public boolean hasChangedViewId(){
    return hasChangedViewId;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertViewId = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenViewId;
  
  /**
   * 
   *
   * getter for BENUTZER_SUCHPARAMETER.VIEW_ID
   */
    @Override   public  java.lang.String getViewId() {
        return viewId;
      }

  /**
   * 
   *
   * setter for BENUTZER_SUCHPARAMETER.VIEW_ID
   *
   * @param viewId
   */
  @Override   public void setViewId( java.lang.String viewId) {

       resetTkCache();
                  
                          java.lang.String viewIdInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(viewId, BenutzerSuchparameterConstants.VIEW_ID_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.viewId
      , viewIdInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedViewId |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("viewId");
      }


             if (!isSeitLadenVeraendertViewId) {
          isSeitLadenVeraendertViewId = thisAttributChanged;
         if (isSeitLadenVeraendertViewId){
           wertNachLadenViewId=this.viewId;
         }
       }
      

       this.viewId = viewIdInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Wahltermin
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHLTERMIN_ID", referencedColumnName="WAHLTERMIN_ID"))
  protected de.ivu.elect.business.wahl.entity.Wahltermin wahltermin;

  /**
   * 
   */
  @Override
  public void setWahltermin( de.ivu.elect.business.wahl.entity.Wahltermin wahltermin){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahltermin
    , wahltermin);

    attributeChanged |= thisAttributChanged;

    hasChangedWahltermin |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahltermin");
    }

    this.wahltermin = wahltermin;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.wahl.entity.Wahltermin getWahltermin(){
    return this.wahltermin;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahltermin = false;

  public boolean hasChangedWahltermin(){
    return hasChangedWahltermin;
  }

  /**
   * Beziehung (unidirektional) zu Wahl
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHL_ID", referencedColumnName="WAHL_ID"))
  protected de.ivu.elect.business.wahl.entity.Wahl wahl;

  /**
   * 
   */
  @Override
  public void setWahl(@javax.annotation.Nullable  de.ivu.elect.business.wahl.entity.Wahl wahl){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahl
    , wahl);

    attributeChanged |= thisAttributChanged;

    hasChangedWahl |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahl");
    }

    this.wahl = wahl;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.wahl.entity.Wahl getWahl(){
    return this.wahl;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahl = false;

  public boolean hasChangedWahl(){
    return hasChangedWahl;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("BenutzerSuchparameter:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(BenutzerSuchparameter other){
                             other.benutzerkennung = this.benutzerkennung;
                                other.name = this.name;
                                other.suchparameter = this.suchparameter;
                                other.viewId = this.viewId;
           
  other.setWahltermin(this.getWahltermin());
  other.setWahl(this.getWahl());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(BenutzerSuchparameter.class)){
        copyEntityAttributesUsingSetter((BenutzerSuchparameter) other.castTo(BenutzerSuchparameter.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von BenutzerSuchparameter: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(BenutzerSuchparameter other){
               other.setBenutzerkennung(this.benutzerkennung);
                  other.setName(this.name);
                  other.setSuchparameter(this.suchparameter);
                  other.setViewId(this.viewId);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(BenutzerSuchparameter other){
                       if (hasChangedBenutzerkennung) {
        other.setBenutzerkennung(this.benutzerkennung);
      }
                             if (hasChangedName) {
        other.setName(this.name);
      }
                             if (hasChangedSuchparameter) {
        other.setSuchparameter(this.suchparameter);
      }
                             if (hasChangedViewId) {
        other.setViewId(this.viewId);
      }
             }





    @javax.persistence.Transient
    private transient BenutzerSuchparameterTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public BenutzerSuchparameterTK getBenutzerSuchparameterTK(){
    if (tkCache==null) {
    tkCache = new BenutzerSuchparameterTK(

getBenutzerkennung()
, getName()
, getViewId()
,   (getWahl() == null) ? null : getWahl().getWahlTK()
,   (getWahltermin() == null) ? null : getWahltermin().getWahlterminTK()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getBenutzerSuchparameterTK();
    }

  @Override
  public BenutzerSuchparameterUK getUk(){
    return getBenutzerSuchparameterUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return BenutzerSuchparameter.class;
  }

public BenutzerSuchparameterUK getBenutzerSuchparameterUK(){

   return  new BenutzerSuchparameterUK(

getBenutzerkennung()
, getName()
, getViewId()
,     getWahl()==null?null:getWahl().getWahlUK()
,     getWahltermin()==null?null:getWahltermin().getWahlterminUK()


  );
}

  @javax.persistence.Transient
  private transient BenutzerSuchparameterProperties properties;

  public BenutzerSuchparameterProperties getProperties(){
    if (properties == null) {
      properties = new BenutzerSuchparameterProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public BenutzerSuchparameterProperties getBenutzerSuchparameterProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return BenutzerSuchparameterConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(BenutzerSuchparameterConstants.MESSAGE_KEY_BENUTZERKENNUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(BenutzerSuchparameterConstants.MESSAGE_KEY_BENUTZERKENNUNG_EINZAHL);

        benutzerkennung =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(BenutzerSuchparameterConstants.MESSAGE_KEY_NAME_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(BenutzerSuchparameterConstants.MESSAGE_KEY_NAME_EINZAHL);

        name =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(BenutzerSuchparameterConstants.MESSAGE_KEY_SUCHPARAMETER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(BenutzerSuchparameterConstants.MESSAGE_KEY_SUCHPARAMETER_EINZAHL);

        suchparameter =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(BenutzerSuchparameterConstants.MESSAGE_KEY_VIEW_ID_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(BenutzerSuchparameterConstants.MESSAGE_KEY_VIEW_ID_EINZAHL);

        viewId =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertBenutzerkennung) {
      result.put(BenutzerSuchparameterConstants.MESSAGE_KEY_BENUTZERKENNUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBenutzerkennung , benutzerkennung));
    }
                            if (isSeitLadenVeraendertName) {
      result.put(BenutzerSuchparameterConstants.MESSAGE_KEY_NAME_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenName , name));
    }
                            if (isSeitLadenVeraendertSuchparameter) {
      result.put(BenutzerSuchparameterConstants.MESSAGE_KEY_SUCHPARAMETER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.LOB
                , wertNachLadenSuchparameter , suchparameter));
    }
                            if (isSeitLadenVeraendertViewId) {
      result.put(BenutzerSuchparameterConstants.MESSAGE_KEY_VIEW_ID_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenViewId , viewId));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertBenutzerkennung = false;
      wertNachLadenBenutzerkennung = null;
                          isSeitLadenVeraendertName = false;
      wertNachLadenName = null;
                          isSeitLadenVeraendertSuchparameter = false;
      wertNachLadenSuchparameter = null;
                          isSeitLadenVeraendertViewId = false;
      wertNachLadenViewId = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "BENUTZER_SUCHPARAMETER";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "BenutzerSuchparameter";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(benutzerkennung, this, BenutzerSuchparameterConstants.MESSAGE_KEY_BENUTZERKENNUNG_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(BenutzerSuchparameterConstants.BENUTZERKENNUNG_MAX_LENGTH , 1 ,  benutzerkennung, this, BenutzerSuchparameterConstants.MESSAGE_KEY_BENUTZERKENNUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(name, this, BenutzerSuchparameterConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(BenutzerSuchparameterConstants.NAME_MAX_LENGTH , 1 ,  name, this, BenutzerSuchparameterConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(suchparameter, this, BenutzerSuchparameterConstants.MESSAGE_KEY_SUCHPARAMETER_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(BenutzerSuchparameterConstants.SUCHPARAMETER_MAX_LENGTH , 1 ,  suchparameter, this, BenutzerSuchparameterConstants.MESSAGE_KEY_SUCHPARAMETER_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(viewId, this, BenutzerSuchparameterConstants.MESSAGE_KEY_VIEW_ID_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(BenutzerSuchparameterConstants.VIEW_ID_MAX_LENGTH , 1 ,  viewId, this, BenutzerSuchparameterConstants.MESSAGE_KEY_VIEW_ID_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
